/*
 *@(#)RSSCreater.java.
 *Copyright (C) 2006 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.help.rss.v20;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

/**
 * RSS(v2.0) ϴ  Ѵ.
 * 
 * <pre>
 * -RSS  ⺻-
 * 
 * &lt?xml version="1.0" encoding="euc-kr" ?&gt
 * &lt rss version="2.0"&gt
 * &lt channel&gt
 * 	&lt title&gt ŸƲ&lt/title&gt
 * 	&lt link&gt http://www.xxxxxx.co.kr&lt/link&gt
 * 	&lt description&gt Description&lt/description&gt
 * 	&lt language&gt ko &lt/language&gt
 * 	&lt lastBuildDate&gt Feb, 26 2006 10:20:30 GMT&lt/lastBuildDate&gt
 * 	&lt webMaster&gt who@xxxxxx.co.kr&lt/webMaster&gt
 * 	&lt item&gt
 * 		&lt title&gt RSS Ͽ&lt/title&gt
 * 		&lt link&gt http://www.xxxxxx.co.kr/xxx/content.jsp?view=bbs&index=23&lt/link&gt
 * 		&lt author&gt ȫ浿&lt/author&gt
 * 		&lt pubDate&gt Feb, 26 2006 10:20:30 GMT&lt/pubDate&gt
 * 		&lt category&gt &lt/category&gt
 * 	&lt/item&gt
 * 	&lt item&gt
 * 		&lt title&gt ̰ 𿡿?&lt/title&gt
 * 		&lt link&gt http://www.xxxxxx.co.kr/java/qna.jsp?view=qnabbs&index=21&lt/link&gt
 * 		&lt author&gt ȫ&lt/author&gt
 * 		&lt pubDate&gt Feb, 13 2006 01:33:48 GMT&lt/pubDate&gt
 * 		&lt category&gt QnA&lt/category&gt
 * 	&lt/item&gt
 * &lt/channel&gt
 * &lt/rss&gt
 * 
 *  : RSSCreater Ŭ 
 * ⺻ RSS شϴ  Է( set) Iitem ̽ 
 * Item addItem޼ҵ带 ̿Ͽ Է ͸ (create)Ѵ.
 *  
 *</pre>
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class RSSCreater {
	//Required channel elements
	private String title;
	private String link;
	private String description;
	//Optional channel elements
	private String language;
	private String copyright;
	private String manageingEditor;
	private String webmaster;
	private Date pubDate;
	private Date lastBuildDate;
	private String category;
	private String docs;
	private String cloud;
	private String ttl;
	private String image;
	private String rating;
	private String textInput;
	private String skipHours;
	private String skipDays;
	
	private List list=null;
    
	private String xmlEncoding;
    private String ĳ;
    private String ;
    /**
     * . RSS ʼ  ڷ ޴´.
     * 
     * @param title .
     * @param link ũ.
     * @param description .
     */
	public RSSCreater(String title,String link,String description){
		this.title=title;
		this.link=link;
		this.description=description;
		
        ĳ="\r\n";
        ="\t";
        
		list=new ArrayList();
	}
	/**
	 * RSSμ  xml  ڵ Ѵ.
	 * ex1)   : <pre><?xml version="1.0"?></pre>
	 * ex2)  (euc-kr) : <pre><?xml version="1.0" encoding="euc-kr" ?></pre>
	 * @param s
	 */
	public void setXMLEncoding(String s){
		this.xmlEncoding=s;
	}
	/**
	 * RSS  item ߰Ѵ.
	 * 
	 * @param item item.
	 */
	public void addItem(Iitem item){
		list.add(item);
	}
	/**
	 * RSS Ѵ.
	 * 
	 * @return RSS(xml)
	 */
	public String create(){
		
		SimpleDateFormat df=new SimpleDateFormat("MMM',' dd yyyy HH:mm:ss 'GMT'",Locale.US);
		
        String gap="";
        if(this.xmlEncoding==null){
            gap+="<?xml version=\"1.0\"?>"+this.ĳ;
            gap+="<rss version=\"2.0\">"+this.ĳ;
            gap+=+"<channel>"+this.ĳ;
        }else{
            gap+="<?xml version=\"1.0\" encoding=\""+this.xmlEncoding+"\"?>"+this.ĳ;
            gap+="<rss version=\"2.0\">"+this.ĳ;
            gap+=+"<channel>"+this.ĳ;
        }        
        if(this.category!=null){gap+=++"<category>"+this.category+"</category>"+this.ĳ;}
        if(this.cloud!=null){gap+=++"<cloud>"+this.cloud+"</cloud>"+this.ĳ;}
        if(this.copyright!=null){gap+=++"<copyright>"+this.copyright+"</copyright>"+this.ĳ;}
        if(this.description!=null){gap+=++"<description>"+this.description+"</description>"+this.ĳ;}
        if(this.docs!=null){gap+=++"<docs>"+this.docs+"</docs>"+this.ĳ;}
        if(this.image!=null){gap+=++"<image>"+this.image+"</image>"+this.ĳ;}
        if(this.language!=null){gap+=++"<language>"+this.language+"</language>"+this.ĳ;}
        if(this.lastBuildDate!=null){gap+=++"<lastBuildDate>"+df.format(this.lastBuildDate)+"</lastBuildDate>"+this.ĳ;}
        if(this.link!=null){gap+=++"<link>"+this.link+"</link>"+this.ĳ;}
        if(this.manageingEditor!=null){gap+=++"<manageingEditor>"+this.manageingEditor+"</manageingEditor>"+this.ĳ;}
        if(this.pubDate!=null){gap+=++"<pubDate>"+df.format(this.pubDate)+"</pubDate>"+this.ĳ;}
        if(this.rating!=null){gap+=++"<rating>"+this.rating+"</rating>"+this.ĳ;}
        if(this.skipDays!=null){gap+=++"<skipDays>"+this.skipDays+"</skipDays>"+this.ĳ;}
        if(this.skipHours!=null){gap+=++"<skipHours>"+this.skipHours+"</skipHours>"+this.ĳ;}
        if(this.textInput!=null){gap+=++"<textInput>"+this.textInput+"</textInput>"+this.ĳ;}
        if(this.title!=null){gap+=++"<title>"+this.title+"</title>"+this.ĳ;}
        if(this.ttl!=null){gap+=++"<ttl>"+this.ttl+"</ttl>"+this.ĳ;}
        if(this.webmaster!=null){gap+=++"<webmaster>"+this.webmaster+"</webmaster>"+this.ĳ;}        
        
        ItemTag tag=null;
		for(int i=0;i<list.size();i++){            
			tag=new ItemTag((Iitem)list.get(i));
            gap+=tag.getTag();            
        }
        
        gap+=+"</channel>"+this.ĳ;
        gap+="</rss>"+this.ĳ;
        
        return gap;
	}
	/**
	 * ä  ֱ(  : ).
	 * ex) <ttl>60</ttl>
	 * 
	 * @param ttl д.
	 */
	public void setTtl(String ttl) {
		this.ttl = ttl;
	}
	/**
	 * @param category Ϸ categoryԴϴ.
	 */
	public void setCategory(String category) {
		this.category = category;
	}
	/**
	 * @param cloud Ϸ cloudԴϴ.
	 */
	public void setCloud(String cloud) {
		this.cloud = cloud;
	}
	/**
	 * @param copyright Ϸ copyrightԴϴ.
	 */
	public void setCopyright(String copyright) {
		this.copyright = copyright;
	}
	/**
	 * @param docs Ϸ docsԴϴ.
	 */
	public void setDocs(String docs) {
		this.docs = docs;
	}
	/**
	 * @param image Ϸ imageԴϴ.
	 */
	public void setImage(String image) {
		this.image = image;
	}
	/**
	 * @param language Ϸ languageԴϴ.
	 */
	public void setLanguage(String language) {
		this.language = language;
	}
	/**
	 * @param lastBuildDate Ϸ lastBuildDateԴϴ.
	 */
	public void setLastBuildDate(Date lastBuildDate) {
		this.lastBuildDate = lastBuildDate;
	}
	/**
	 * @param list Ϸ listԴϴ.
	 */
	public void setList(List list) {
		this.list = list;
	}
	/**
	 * @param manageingEditor Ϸ manageingEditorԴϴ.
	 */
	public void setManageingEditor(String manageingEditor) {
		this.manageingEditor = manageingEditor;
	}
	/**
	 * @param pubDate Ϸ pubDateԴϴ.
	 */
	public void setPubDate(Date pubDate) {
		this.pubDate = pubDate;
	}
	/**
	 * @param rating Ϸ ratingԴϴ.
	 */
	public void setRating(String rating) {
		this.rating = rating;
	}
	/**
	 * @param skipDays Ϸ skipDaysԴϴ.
	 */
	public void setSkipDays(String skipDays) {
		this.skipDays = skipDays;
	}
	/**
	 * @param skipHours Ϸ skipHoursԴϴ.
	 */
	public void setSkipHours(String skipHours) {
		this.skipHours = skipHours;
	}
	/**
	 * @param textInput Ϸ textInputԴϴ.
	 */
	public void setTextInput(String textInput) {
		this.textInput = textInput;
	}
	/**
	 * @param webmaster Ϸ webmasterԴϴ.
	 */
	public void setWebmaster(String webmaster) {
		this.webmaster = webmaster;
	}
    private class ItemTag{
        Iitem item;
        String ĳ;
        String ;
        
        ItemTag(Iitem item){
           this.item=item;
           ĳ="\r\n";
           ="\t";
        }
        String getTag(){
        	
        	SimpleDateFormat df=new SimpleDateFormat("MMM',' dd yyyy HH:mm:ss 'GMT'",Locale.US);
        	
            if(item==null){
                return "";
            }else{
            	String gap=++"<item>"+this.ĳ;
                if(item.getTitle()!=null){gap+=+++"<title>"+item.getTitle()+"</title>"+this.ĳ;}
                if(item.getAuthor()!=null){gap+=+++"<author>"+item.getAuthor()+"</author>"+this.ĳ;}
                if(item.getCategory()!=null){gap+=+++"<category>"+item.getCategory()+"</category>"+this.ĳ;}
                if(item.getComments()!=null){gap+=+++"<comments>"+item.getComments()+"</comments>"+this.ĳ;}
                if(item.getDescription()!=null){gap+=+++"<description>"+item.getDescription()+"</description>"+this.ĳ;}
                if(item.getEnclosure()!=null){gap+=+++"<enclosure>"+item.getEnclosure()+"</enclosure>"+this.ĳ;}
                if(item.getGuid()!=null){gap+=+++"<guid>"+item.getGuid()+"</guid>"+this.ĳ;}
                if(item.getLink()!=null){gap+=+++"<link>"+item.getLink()+"</link>"+this.ĳ;}
                if(item.getPubDate()!=null){gap+=+++"<pubdate>"+df.format(item.getPubDate())+"</pubdate>"+this.ĳ;}
                if(item.getSource()!=null){gap+=+++"<source>"+item.getSource()+"</source>"+this.ĳ;}
                
                gap+=++"</item>"+this.ĳ;
                return gap;
            }
        }
    }
}
