/*
 *@(#)TableRow.java
 *Copyright (C) 2006 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */

package iiixzu.help.sql;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Map;

/**
 * Ϲ DB̺    ִ  մϴ. 
 * ǥ SQL Ϲ DB ۵˴ϴ. 
 *  1 Row ͸  ˴ϴ.
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class TableRow implements ITableRow {
    
    private String query;
    private Map map;
     
    private boolean isExist;
    private String tableName;
    private String where;
    private int rowCount;
    private Map columnNames;
    
    /**
     * .
     * @param query SQL SELECT . 1 row μ ȴ. 
     * @param con Connection ü..
     * @throws SQLException sql ܰ ߻.
     */
    public TableRow(String query,Connection con) throws SQLException{
        this.query=query.trim();
        map=new HashMap();
        columnNames=new HashMap();
        parsing();      
        rowCount(con);
        if(!(rowCount==0||rowCount==1)){
        	throw new SQLException("#row's count is not 1");
        }
        getQuery(con);
    }
    private void getQuery(Connection con) throws SQLException{
        PreparedStatement pstmt1=null;
        ResultSet resultSet1=null;
        ResultSetMetaData metaData1=null;
        int columnCount=0;
        
        pstmt1=con.prepareStatement(query);
        resultSet1=pstmt1.executeQuery();
        metaData1=resultSet1.getMetaData();
        columnCount=metaData1.getColumnCount();
        
        if(resultSet1.next()){
                      
            for(int i=0;i<columnCount;i++){
                map.put(metaData1.getColumnName(i+1).toLowerCase(),resultSet1.getObject(i+1));             
                columnNames.put(i+"",metaData1.getColumnName(i+1).toLowerCase());
             }        
            this.isExist=true;
        }else{
            this.isExist=false;
        }
    }
    private void parsing()throws SQLException{
        
        String temp=this.query.toLowerCase();
        
        if(!temp.startsWith("select")){
        	throw new SQLException("Query is not start \"SELECT\"");
        }
        if(temp.indexOf("where")!=-1){
            tableName=temp.substring(temp.indexOf("from")+4,temp.lastIndexOf("where"));
            where=temp.substring(temp.indexOf("where")+5,temp.length());
            tableName=tableName.trim();
            where=where.trim();
        }else{
            tableName=temp.substring(temp.indexOf("from")+4,temp.length());
            tableName=tableName.trim();
        }
    }
    /**
     * row  üũ..
     * @return row
     * @throws SQLException sql ߻.
     */
    private void rowCount(Connection con) throws SQLException{
        
        String query1="select count(*) from "+tableName;
        
        PreparedStatement pstmt1=null;
        ResultSet resultSet1=null;
        
        try {
            pstmt1=con.prepareStatement(query1);
            resultSet1=pstmt1.executeQuery();
            
            if(resultSet1.next()){
                this.rowCount=resultSet1.getInt(1);
            }else{
                this.rowCount=0;
            }
        } catch (SQLException e) {
           throw e;
        }finally{
            if(resultSet1!=null){resultSet1.close();}
			if(pstmt1!=null){pstmt1.close();}
        }
    }
    /* (Javadoc)
	 * @see iiixzu.help.sql.ITableRow#isExist()
	 */
    public boolean isExist(){
        return isExist;
    }
    /**
	 * Row شϴ ͸ Ѵ.
	 * @return true : ,false : Ȯ 1 . 
	 */
    public boolean delete(Connection con)throws SQLException{
    	String query="delete from "+this.tableName+" where "+this.where;
    	Statement stmt1=null;
    	
    	try {
			stmt1=con.createStatement();
			int result=stmt1.executeUpdate(query);
			
			if(result!=1){
				return false;
			}else{
				this.isExist=false;
				return true;
			}		
		}finally{
			if(stmt1!=null){stmt1.close();}
		}
    }
    /* (Javadoc)
	 * @see iiixzu.help.sql.ITableRow#getColumns(java.lang.String)
	 */
    public Object getColumns(String columnName){
    	if(this.isExist()){
    		return map.get(columnName.toLowerCase());
    	}else{
    		return null;
    	}
    }
    /* (Javadoc)
	 * @see iiixzu.help.sql.ITableRow#getColumns(int)
	 */
    public Object getColumns(int index){   
    	if(this.isExist()){
    		int tempIndex=index-1;        
    		return map.get(columnNames.get(tempIndex+""));
    	}else{
    		return null;
    	}
    }
}
