/*
 *@(#)Request.java
 *Copyright (C) 2006 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.help.web;

import java.io.Serializable;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;

/**
 * HttpServletRequest  ϰ ̿ϱ ȴ.  POST,GET޼ҵ忡 ؼ
 *  ϰԲ Ǿ ַ Ͼε ɵ ϰ HeepServletRequest ϰԵ
 *  ̿ ̰ Բ ϴ°  .
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class Request implements Serializable{
	
	private static final long serialVersionUID = 4334241447452522460L;
	private String contentType;
	private String method;
	private String servletPath;//  ΰ.
	private String queryString;
	private String remoteHost;
	private String remoteAddr;
	private int remotePort; //Ʈȣ;
	private Map parameterMap;
	private Map queryStringMap;
	private Map fileMap;
			
	/**
	 * .
	 * multipart/form-data ϰ ϵ  ϸ, ׿ 쿣 ϸ  Ѵ.
	 * @param request HttpServletRequestü.
	 */
	public Request(HttpServletRequest request) throws Exception{
		
		contentType=request.getContentType();
		if(contentType!=null){
			contentType=contentType.toLowerCase();
		}
		method=request.getMethod();
		
		servletPath="";
		queryString="";
		parameterMap=new HashMap();
		queryStringMap=new HashMap();
		
		fileMap=new HashMap();
		
		if(contentType!=null&&contentType.startsWith("multipart")){
			DiskFileUpload fileUpload=new DiskFileUpload();
			List list=fileUpload.parseRequest(request);
			
			//FileItem[] fileItems=new FileItem[list.size()];
			
			FileItem formField=null;
			
			for(int i=0;i<list.size();i++){
				formField=(FileItem)list.get(i);
				if(formField.isFormField()){
					parameterMap.put(formField.getFieldName(),formField.getString());
				}else{
					fileMap.put(formField.getName(),formField.get());
				}
			}
			servletPath=request.getServletPath();
			queryString=request.getQueryString();
			
			remotePort=request.getLocalPort();
			remoteHost=request.getRemoteHost();
			remoteAddr=request.getRemoteAddr();
			
		}else if(method.equals("POST")){
			servletPath=request.getServletPath();
			queryString=request.getQueryString();
			remotePort=request.getRemotePort();
			remoteHost=request.getRemoteHost();
			remoteAddr=request.getRemoteAddr();
			
			this.parameterMap=new HashMap();
			Enumeration e=request.getParameterNames();
			String key=null;
			while(e.hasMoreElements()){
				key=(String)e.nextElement();
				parameterMap.put(key,request.getParameter(key));
			}
			//ƷͰ  ѰʾƼ ... Ѵ..
			//this.parameters=request.getParameterMap();
		}else if(method.equals("GET")){
			servletPath=request.getServletPath();
			queryString=request.getQueryString();
			remotePort=request.getRemotePort();
			remoteHost=request.getRemoteHost();
			remoteAddr=request.getRemoteAddr();
		}else{
			//..
		}
		//Ʈ.
		queryString=queryString==null?"":queryString;
		if(!queryString.equals("")){
			String[] temp=queryString.split("&");
			String[] temp2=null;
			for(int i=0;i<temp.length;i++){
				temp2=temp[i].split("=");
				if(temp2.length==1){
					queryStringMap.put(temp2[0],"");
				}else{
					queryStringMap.put(temp2[0],temp2[1]);
				}				
			}
		}
	}
	/**
	 * ϸ ´.
	 * @return ϸ.
	 */
	public String getServletPath(){
		return servletPath;
	}
	/**
	 * queryString ´.
	 * @return .
	 */
	public String getQuerystring(){
		return queryString;
	}
	/**
	 * parameter  ´.
	 * key=value ̷ map · Ķ= · ִ.
	 * @return Map.
	 */
	public Map getParameterMap(){
		Map temp=new HashMap();
		temp.putAll(parameterMap);
		temp.putAll(queryStringMap);
		
		return temp;
	}
	/**
	 * ĶͰ ´.
	 * @param s ĶŰ
	 * @return ĸͰ
	 */
	public String getParameter(String s){
		String returnValue=null;
		returnValue=(String)parameterMap.get(s);
		if(returnValue==null){
			return (String)queryStringMap.get(s);
		}else{
			return returnValue;
		}
	}
	/**
	 * ϸ ´.
	 * key=value ̷ map · ϸ= ·  ִ.
	 * @return Map.
	 */
	public Map getFileMap(){
		return fileMap;
	}
	/**
	 * ContentType.
	 *  
	 * @return ContentType. ) ƼƮϰ multipart/form-data
	 */
	public String getContentType(){
		return this.contentType;
	}
	/**
	 * method ´.
	 * @return GET or POST .
	 */
	public String getMethod(){
		return this.method;
	}
	/**
	 * Ʈȣ ´.
	 * @return Ʈȣ.
	 */
	public int getRemotePort(){
		return this.remotePort;
	}
	/**
	 * Host ´.
	 * @return ȣƮ.
	 */
	public String getRemoteHost(){
		return this.remoteHost;
	}
	/**
	 * Addr ´.
	 * @return RemoteAddr;
	 */
	public String getRemoteAddr(){
		return this.remoteAddr;
	}	
	/**
	 * ContentType Ѵ.
	 * @param s ContentType.
	 */
	public void setContentType(String s){
		this.contentType=s;
	}
	/**
	 * Method Ѵ.
	 * @param s ޼ҵ.
	 */
	public void setMethod(String s){
		this.method=s;
	}
	/**
	 * ȣ  Ѵ.
	 * @param s ȣ⼭.
	 */
	public void setServletPath(String s){
		this.servletPath=s;
	}	
	/**
	 * Ķ͸ ߰Ѵ.
	 * 
	 * @param key Ű.
	 * @param value .
	 */
	public void addParameter(String key,String value){
		this.parameterMap.put(key,value);
	}
	/**
	 *  ߰Ѵ.
	 * @param key Ű.
	 * @param value .
	 */
	public void addQueryString(String key,String value){
		this.queryStringMap.put(key,value);
	}
	/**
	 *  ߰Ѵ.
	 * @param fileName ϸ.
	 * @param file .
	 */
	public void addFile(String fileName,byte[] file){
		this.fileMap.put(fileName,file);
	}	
}
